org.eclipse.incquery.viewmodel.traceablilty.generic

## Class GenericReferencedPQuery

- java.lang.Object
- - org.eclipse.incquery.runtime.matchers.psystem.queries.BasePQuery
  - - org.eclipse.incquery.runtime.api.impl.BaseGeneratedEMFPQuery
    - - org.eclipse.incquery.viewmodel.traceablilty.generic.GenericReferencedPQuery

- All Implemented Interfaces:
    PQuery, PQueryHeader
  Direct Known Subclasses:
    GenericTracedPQuery

      public class GenericReferencedPQuery
      extends BaseGeneratedEMFPQuery

  This PQuery class defines an extended query for the given base query with the additionally referenced parameters.

      pattern baseQuery<referenced>(<base parameters>, <referenced parameters>)

  This PQuery selects the referenced parameters to apply the appear operation properly
  Author:
    Csaba Debreceni

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.eclipse.incquery.runtime.matchers.psystem.queries.PQuery

      `PQuery.PQueryStatus`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GenericReferencedPQuery(GenericReferencedPQuery referencedQuery)`
    `GenericReferencedPQuery(PQuery baseQuery, com.google.common.collect.Multimap<PParameter,PParameter> traceSources, java.util.Map<PParameter,java.lang.String> traceIds, java.lang.String traceabilityId)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getFullyQualifiedName()` Identifies the pattern for which matchers can be instantiated.
    `java.util.List<PParameter>` | `getParameters()` Returns a list of parameter descriptions
    `java.util.Set<PParameter>` | `getReferenceParameters()`
    `com.google.common.collect.Multimap<PParameter,PParameter>` | `getReferenceSources()`
    `java.lang.String` | `getTraceabilityId()`

    - ### Methods inherited from class org.eclipse.incquery.runtime.matchers.psystem.queries.BasePQuery

      `checkMutability, ensureInitialized, ensureInitializedSneaky, getAllAnnotations, getAllReferredQueries, getAnnotationsByName, getDirectReferredQueries, getDisjunctBodies, getEvaluationHints, getFirstAnnotationByName, getParameterNames, getPositionOfParameter, getPProblems, getStatus, isMutable, publishedAs`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GenericReferencedPQuery

          public GenericReferencedPQuery(GenericReferencedPQuery referencedQuery)
                                  throws QueryInitializationException

      Throws:
        `QueryInitializationException`

    - #### GenericReferencedPQuery

          public GenericReferencedPQuery(PQuery baseQuery,
                                         com.google.common.collect.Multimap<PParameter,PParameter> traceSources,
                                         java.util.Map<PParameter,java.lang.String> traceIds,
                                         java.lang.String traceabilityId)
                                  throws QueryInitializationException

      Throws:
        `QueryInitializationException`

  - ### Method Detail

    - #### getFullyQualifiedName

          public java.lang.String getFullyQualifiedName()

      Description copied from interface: `PQueryHeader`
      Identifies the pattern for which matchers can be instantiated.

    - #### getParameters

          public java.util.List<PParameter> getParameters()

      Description copied from interface: `PQueryHeader`
      Returns a list of parameter descriptions
      Returns:
        a non-null, but possibly empty list of parameter descriptions

    - #### getReferenceSources

          public com.google.common.collect.Multimap<PParameter,PParameter> getReferenceSources()

    - #### getReferenceParameters

          public final java.util.Set<PParameter> getReferenceParameters()

    - #### getTraceabilityId

          public java.lang.String getTraceabilityId()